frr defaults datacenter
hostname {{ inventory_hostname }}
username cumulus nopassword
!
service integrated-vtysh-config
!
log syslog informational
!
ip pim rp {{ multicast.underlay[devices[inventory_hostname].site].rpaddr|ipaddr('address') }} 224.0.0.0/4
ip pim ecmp
ip pim keep-alive-timer 3600
!
{% set l3 = tenants.l3domain %}
{% for domain in l3 %}
{% if domain in devices[inventory_hostname].vrfs %}
vrf {{ domain }}
{% endif %}
{% endfor %}
!
{% set mcastrouting = devices[inventory_hostname].routing.pim.vrf %}
{% for vrf in mcastrouting %}
{% if mcastrouting[vrf].rp is defined %}
{% if vrf != "default" %}
{% if mcastrouting[vrf].rp %}
interface {{ vrf }}
 ip pim
 ip pim use-source {{ devices[inventory_hostname].vrfs[vrf].ipv4|ipaddr('address') }}
{% endif %}
{% endif %}
{% endif %}
{% for interface in mcastrouting[vrf].interface %}
interface {{ interface }}
 ip pim sm
{% endfor %}
{% endfor %}
!
router bgp {{ devices[inventory_hostname].routing.bgp.asn }}
 bgp router-id {{ devices[inventory_hostname].interfaces.loopback.ipv4|ipaddr('address') }}
 bgp bestpath as-path multipath-relax
 neighbor dci peer-group
 neighbor dci remote-as external
{% for peer in devices[inventory_hostname].routing.bgp.vrf.default.neighbor %}
 {% set neighbor = devices[inventory_hostname].routing.bgp.vrf.default.neighbor[peer] %}
 neighbor {{ peer }} peer-group dci
{% endfor %}
 !
 address-family ipv4 unicast
  redistribute connected route-map routing-default 
 exit-address-family
 !
 address-family ipv6 unicast
  neighbor dci activate
 exit-address-family
 !
!
{% for vrf in devices[inventory_hostname].vrfs %}
router bgp {{ devices[inventory_hostname].routing.bgp.asn }} vrf {{ vrf }}
 bgp router-id {{ devices[inventory_hostname].interfaces.loopback.ipv4|ipaddr('address') }}
 neighbor dci peer-group
 neighbor dci remote-as external
{% for peer in devices[inventory_hostname].routing.bgp.vrf[vrf].neighbor %}
 {% set neighbor = devices[inventory_hostname].routing.bgp.vrf[vrf].neighbor[peer] %}
 neighbor {{ peer }} peer-group dci
{% endfor %}
 !
 address-family ipv4 unicast
  redistribute connected route-map routing-{{ vrf }}
 exit-address-family
 !
 address-family ipv6 unicast
  neighbor dci activate
 exit-address-family
 !
{% endfor %}
!
route-map routing-default permit 10
 match interface lo
{% for interface in devices[inventory_hostname].interfaces.routed %}
{% if "default" == devices[inventory_hostname].interfaces.routed[interface].vrf %}
{% if not devices[inventory_hostname].interfaces.routed[interface].unnumbered %}
route-map routing-default permit 10{{ loop.index }}
 match interface {{ interface }}
{% endif %}
{% endif %}
{% endfor %}
!
{% for vrf in devices[inventory_hostname].vrfs %}
route-map routing-{{ vrf }} permit 10
 match interface {{ vrf }}
{% for interface in devices[inventory_hostname].interfaces.routed %}
{% if vrf == devices[inventory_hostname].interfaces.routed[interface].vrf %}
{% if not devices[inventory_hostname].interfaces.routed[interface].unnumbered %}
route-map routing-{{ vrf }} permit 10{{ loop.index }}
 match interface {{ interface }}
{% endif %}
{% endif %}
{% endfor %}
!
{% endfor %}
!
line vty
!
